---
title: NodeList.keys()
slug: Web/API/NodeList/keys
tags:
  - DOM
  - Iterator
  - Method
  - NodeList
  - Reference
  - Web
---
<p>{{APIRef("DOM")}}</p>

<p>The <code><strong>NodeList.keys()</strong></code> method returns an {{jsxref("Iteration_protocols",'iterator')}} allowing to go through all keys contained in this object. The keys are <code>unsigned integer</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">nodeList.keys();</pre>

<h3 id="Return_value">Return value</h3>

<p>Returns an {{jsxref("Iteration_protocols","iterator")}}.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js;highlight:[13]">var node = document.createElement("div");
var kid1 = document.createElement("p");
var kid2 = document.createTextNode("hey");
var kid3 = document.createElement("span");

node.appendChild(kid1);
node.appendChild(kid2);
node.appendChild(kid3);

var list = node.childNodes;

// Using for..of
for(var key of list.keys()) {
   console.log(key);
}
</pre>

<p>The result is:</p>

<pre>0
1
2
</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.NodeList.keys")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("Node")}}</li>
	<li>{{domxref("NodeList")}}</li>
</ul>
